'''''''''''''''''''''''''''''''''''''
' Craig Persiko
' CS 141B Command Examples
' Some code copied from Database Access with Visual Basic .NET 
'   by McManus and Goldstein
'''''''''''''''''''''''''''''''''''''

Option Strict On
Imports System.Data.SqlClient

Public Class frmDataReaderExample
    Inherits System.Windows.Forms.Form

    Private conNovelty As SqlConnection

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents txtResults As System.Windows.Forms.TextBox

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents btnExecuteReader As System.Windows.Forms.Button
    Friend WithEvents btnExecuteNonQuery As System.Windows.Forms.Button
    Friend WithEvents btnExecuteProc As System.Windows.Forms.Button
    Friend WithEvents btnScalar As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.txtResults = New System.Windows.Forms.TextBox()
        Me.btnExecuteReader = New System.Windows.Forms.Button()
        Me.btnExecuteNonQuery = New System.Windows.Forms.Button()
        Me.btnExecuteProc = New System.Windows.Forms.Button()
        Me.btnScalar = New System.Windows.Forms.Button()
        Me.SuspendLayout()
        '
        'txtResults
        '
        Me.txtResults.Font = New System.Drawing.Font("Microsoft Sans Serif", 10.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtResults.Location = New System.Drawing.Point(192, 16)
        Me.txtResults.Multiline = True
        Me.txtResults.Name = "txtResults"
        Me.txtResults.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.txtResults.Size = New System.Drawing.Size(480, 384)
        Me.txtResults.TabIndex = 0
        Me.txtResults.Text = ""
        '
        'btnExecuteReader
        '
        Me.btnExecuteReader.Location = New System.Drawing.Point(16, 144)
        Me.btnExecuteReader.Name = "btnExecuteReader"
        Me.btnExecuteReader.Size = New System.Drawing.Size(128, 24)
        Me.btnExecuteReader.TabIndex = 6
        Me.btnExecuteReader.Text = "ExecuteReader"
        '
        'btnExecuteNonQuery
        '
        Me.btnExecuteNonQuery.Location = New System.Drawing.Point(16, 24)
        Me.btnExecuteNonQuery.Name = "btnExecuteNonQuery"
        Me.btnExecuteNonQuery.Size = New System.Drawing.Size(128, 23)
        Me.btnExecuteNonQuery.TabIndex = 7
        Me.btnExecuteNonQuery.Text = "Create Procedure"
        '
        'btnExecuteProc
        '
        Me.btnExecuteProc.Location = New System.Drawing.Point(16, 64)
        Me.btnExecuteProc.Name = "btnExecuteProc"
        Me.btnExecuteProc.Size = New System.Drawing.Size(128, 23)
        Me.btnExecuteProc.TabIndex = 8
        Me.btnExecuteProc.Text = "Execute Procedure"
        '
        'btnScalar
        '
        Me.btnScalar.Location = New System.Drawing.Point(16, 104)
        Me.btnScalar.Name = "btnScalar"
        Me.btnScalar.Size = New System.Drawing.Size(128, 23)
        Me.btnScalar.TabIndex = 9
        Me.btnScalar.Text = "Execute Scalar"
        '
        'frmDataReaderExample
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(704, 429)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.btnScalar, Me.btnExecuteProc, Me.btnExecuteNonQuery, Me.btnExecuteReader, Me.txtResults})
        Me.Name = "frmDataReaderExample"
        Me.Text = "Command Examples"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub frmDataReaderExample_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Create an instance of a Connection object
        conNovelty = New SqlConnection( _
                    "data source=L-BAT361-CPERSI\VSDOTNET;initial catalog=novelty;" & _
                    "integrated security=SSPI;persist security info=False;" & _
                    "workstation id=L-BAT361-CPERSI;packet size=4096")
        conNovelty.Open()
        txtResults.Text = "Connection is " & conNovelty.State.ToString()
    End Sub

    Private Sub frmDataReaderExample_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        conNovelty.Close()
    End Sub

    Private Sub btnExecuteNonQuery_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExecuteNonQuery.Click
        Dim sql As String
        Dim result As Integer

        ' Create instance of Command object
        Dim cmd As SqlCommand = New SqlCommand()

        ' Set command's connection and command text
        cmd.Connection = conNovelty
        cmd.CommandType = CommandType.Text

        ' Assign SQL statement to create a new Stored Procedure
        sql = "CREATE PROCEDURE  RetailPrice @ID int" & _
          " AS declare @price money" & _
          " select  @price = RetailPrice from tblInventory " & _
          " where ID = @ID" & _
          " return (@price)"

        txtResults.Text = sql  ' display query
        cmd.CommandText = sql  ' set command to use query

        ' We need to put the code inside a Try-Catch block
        ' since a failed command ALSO generates a run-time error
        Try
            result = cmd.ExecuteNonQuery()
        Catch ex As Exception
            ' Display error message
            MessageBox.Show(ex.Message)
        End Try

        ' Show results of command execution
        If result = -1 Then
            MessageBox.Show("Command completed successfully")
        Else
            MessageBox.Show("Command execution failed")
        End If
    End Sub

    Private Sub btnExecuteProc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExecuteProc.Click
        ' Create instances of Command and paramter objects
        Dim cmd As SqlCommand = New SqlCommand()
        Dim prm As SqlParameter = New SqlParameter()
        Dim result As Integer

        txtResults.Clear()

        ' Set command's connection and command text
        cmd.Connection = conNovelty
        cmd.CommandType = CommandType.StoredProcedure
        cmd.CommandText = "RetailPrice"

        'Create input parameter and set value
        cmd.Parameters.Add(New SqlParameter("@ID", SqlDbType.Int))
        cmd.Parameters("@ID").Value = "2"
        cmd.Parameters("@ID").Direction = ParameterDirection.Input

        'Create output parameter and set value
        cmd.Parameters.Add(New SqlParameter("@price", SqlDbType.Money))
        cmd.Parameters("@price").Direction = ParameterDirection.ReturnValue

        ' Write out command string 
        txtResults.Text = "Command String:" & ControlChars.CrLf
        txtResults.Text = txtResults.Text & ControlChars.Tab & _
           cmd.CommandText() & ControlChars.CrLf

        ' Write out command parameters and values 
        txtResults.Text = txtResults.Text & "Command parameters:" & _
                            ControlChars.CrLf
        For Each prm In cmd.Parameters
            txtResults.Text = txtResults.Text & ControlChars.Tab & _
            prm.ParameterName & "  =  " & Format(prm.Value) & ControlChars.CrLf
        Next

        ' We need to put the code inside a Try-Catch block
        ' since a failed command ALSO generates a run-time error
        Try
            result = cmd.ExecuteNonQuery()
        Catch ex As Exception
            ' Display error message
            MessageBox.Show(ex.Message)
        End Try

        ' Show results of command execution
        If result = 0 Then
            txtResults.Text &= "Command execution failed"
        Else
            txtResults.Text &= "Command completed successfully" & _
                               " inventory ID 2 retail price is: " & _
                               Format(cmd.Parameters("@price").Value, "Currency")

        End If

    End Sub

    Private Sub btnScalar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnScalar.Click
        Dim numItems As Integer
        ' Create instance of Command object
        Dim cmd As SqlCommand = New SqlCommand()
        ' Set command's connection and command text
        cmd.Connection = conNovelty
        cmd.CommandType = CommandType.Text
        cmd.CommandText = "SELECT count(*) FROM tblInventory WHERE RetailPrice < 5"
        numItems = CInt(cmd.ExecuteScalar())
        txtResults.Text = "Query was successful.  There are " & _
                CStr(numItems) & " items under $5.00"
    End Sub

    Private Sub btnExecuteReader_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnExecuteReader.Click

        ' Create instance of Command object
        Dim cmd As SqlCommand = New SqlCommand()
        ' Set command's connection and command text
        cmd.Connection = conNovelty
        cmd.CommandType = CommandType.Text
        cmd.CommandText = "SELECT ProductName, Description FROM tblInventory"

        Dim reader As SqlDataReader
        reader = cmd.ExecuteReader()

        txtResults.Clear()
        While reader.Read()
            txtResults.Text = txtResults.Text & reader.GetString(0) & _
                                ControlChars.Tab & reader.GetString(1) & _
                                ControlChars.CrLf
        End While
        reader.Close()
    End Sub
End Class
